// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

package azure

const (
	ApplicationAdministratorRole                = "9b895d92-2cd3-44c7-9d02-a6ac2d5ea5c3"
	ApplicationDeveloperRole                    = "cf1c38e5-3621-4004-a7cb-879624dced7c"
	AuthenticationAdministratorRole             = "c4e39bd9-1100-46d3-8c65-fb160da0071f"
	AzureDevOpsAdministratorRole                = "e3973bdf-4987-49ae-837a-ba8e231c7286"
	AzureInformationProtectionAdministratorRole = "7495fdc4-34c4-4d15-a289-98788ce399fd"
	B2CIEFKeySetAdministratorRole               = "aaf43236-0c0d-4d5f-883a-6955382ac081"
	B2CIEFPolicyAdministrator                   = "3edaf663-341e-4475-9f94-5c398ef6c070"
	B2CUserFlowAdministratorRole                = "6e591065-9bad-43ed-90f3-e9424366d2f0"
	B2CUserFlowAttributeAdministratorRole       = "0f971eea-41eb-4569-a71e-57bb8a3eff1e"
	WorkplaceDeviceJoinRole                     = "c34f683f-4d5a-4403-affd-6615e00e3a7f"
	BillingAdministratorRole                    = "b0f54661-2d74-4c50-afa3-1ec803f12efe"
	CloudApplicationAdministratorRole           = "158c047a-c907-4556-b7ef-446551a6b5f7"
	CloudDeviceAdministratorRole                = "7698a772-787b-4ac8-901f-60d6b08affd2"
	CompanyAdministratorRole                    = "62e90394-69f5-4237-9190-012177145e10"
	ComplianceAdministratorRole                 = "17315797-102d-40b4-93e0-432062caca18"
	ComplianceDataAdministratorRole             = "e6d1a23a-da11-4be4-9570-befc86d067a7"
	ConditionalAccessAdministratorRole          = "b1be1c3e-b65d-4f19-8427-f6fa0d97feb9"
	CRMServiceAdministratorRole                 = "44367163-eba1-44c3-98af-f5787879f96a"
	CustomerLockBoxAccessApproverRole           = "5c4f9dcd-47dc-4cf7-8c9a-9e4207cbfc91"
	DesktopAnalyticsAdministratorRole           = "38a96431-2bdf-4b4c-8b6e-5d3d8abac1a4"
	DeviceAdministratorsRole                    = "9f06204d-73c1-4d4c-880a-6edb90606fd8"
	DeviceJoinRole                              = "9c094953-4995-41c8-84c8-3ebb9b32c93f"
	DeviceManagersRole                          = "2b499bcd-da44-4968-8aec-78e1674fa64d"
	DeviceUsersRole                             = "d405c6df-0af8-4e3b-95e4-4d06e542189e"
	UserAccountAdministratorRole                = "fe930be7-5e62-47db-91af-98c3a49a38b1"
	DirectoryReadersRole                        = "88d8e3e3-8f55-4a1e-953a-9b9898b8876b"
	DirectorySynchronizationAccountsRole        = "d29b2b05-8046-44ba-8758-1e26182fcf32"
	DirectoryWritersRole                        = "9360feb5-f418-4baa-8175-e2a00bac4301"
	TeamsServiceAdministratorRole               = "69091246-20e8-4a56-aa4d-066075b2a7a8"
	TeamsCommunicationsSupportSpecialistRole    = "fcf91098-03e3-41a9-b5ba-6f0ec8188a12"
	TeamsCommunicationsSupportEngineerRole      = "f70938a0-fc10-4177-9e90-2178f8765737"
	TeamsCommunicationsAdministratorRole        = "baf37b3a-610e-45da-9e62-d9d1e5e8914b"
	SharePointServiceAdministratorRole          = "f28a1f50-f6e7-4571-818b-6a12f2af6b6c"
	ServiceSupportAdministratorRole             = "f023fd81-a637-4b56-95fd-791ac0226033"
	SecurityReaderRole                          = "5d6b6bb7-de71-4623-b4af-96380a352509"
	SecurityOperatorRole                        = "5f2222b1-57c3-48ba-8ad5-d4759f1fde6f"
	SecurityAdministratorRole                   = "194ae4cb-b126-40b2-bd5b-6091b380977d"
	SearchEditorRole                            = "8835291a-918c-4fd7-a9ce-faa49f0cf7d9"
	SearchAdministratorRole                     = "0964bb5e-9bdb-4d7b-ac29-58e794862a40"
	ReportsReaderRole                           = "4a5d8f65-41da-4de4-8968-e035b65339cf"
	PrivilegedRoleAdministratorRole             = "e8611ab8-c189-46e8-94e1-60213ab1f814"
	PrivilegedAuthenticationAdministratorRole   = "7be44c8a-adaf-4e2a-84d6-ab2649e08a13"
	PrinterTechnicianRole                       = "e8cef6f1-e4bd-4ea8-bc07-4b8d950f4477"
	PrinterAdministratorRole                    = "644ef478-e28f-4e28-b9dc-3fdde9aa0b1f"
	PowerPlatformAdministratorRole              = "11648597-926c-4cf3-9c36-bcebb0ba8dcc"
	PowerBIServiceAdministratorRole             = "a9ea8996-122f-4c74-9520-8edcd192826c"
	PasswordAdministratorRole                   = "966707d0-3269-4727-9be2-8c3a10f19b9d"
	PartnerTier2SupportRole                     = "e00e864a-17c5-4a4b-9c06-f5b95a8d5bd8"
	PartnerTier1SupportRole                     = "4ba39ca4-527c-499a-b93d-d9b492c50246"
	OfficeAppsAdministratorRole                 = "2b745bdf-0803-4d80-aa65-822c4493daac"
	MessageCenterReaderRole                     = "790c1fb9-7f7d-4f88-86a1-ef1f95c05c1b"
	MessageCenterPrivacyReaderRole              = "ac16e43d-7b2d-40e0-ac05-243ff356ab5b"
	LyncServiceAdministratorRole                = "75941009-915a-4869-abe7-691bff18279e"
	LicenseAdministratorRole                    = "4d6ac14f-3453-41d0-bef9-a3e0c569773a"
	KaizalaAdministratorRole                    = "74ef975b-6605-40af-a5d2-b9539d836353"
	IntuneServiceAdministratorRole              = "3a2c62db-5318-420d-8d74-23affee5d9d5"
	HelpdeskAdministratorRole                   = "729827e3-9c14-49f7-bb1b-9608f156bbb8"
	GuestInviterRole                            = "95e79109-95c0-4d8e-aee3-d01accf2d47b"
	GroupsAdministratorRole                     = "fdd7a751-b60b-444a-984c-02652fe8fa1c"
	GlobalReaderRole                            = "f2ef992c-3afb-46b9-b7cf-a126ee74c451"
	ExternalIdentityProviderAdministratorRole   = "be2f45a1-457d-42af-a067-6ec1fa63bc45"
	ExchangeServiceAdministrator                = "29232cdf-9323-42fd-ade2-1d097af3e4de"
	VirtualMachineContributor                   = "9980e02c-c2be-4d73-94e8-173b1dc7cf3c"
	IdentityGovernanceAdministrator             = "45d8d3c5-c802-45c6-b32a-1d70b5e1e86e"
	KnowledgeAdministratorRole                  = "b5a8dcf3-09d5-43a9-a639-8e29ef291470"
	KnowledgeManagerRole                        = "744ec460-397e-42ad-a462-8b3f9747a02c"
	OwnerRole                                   = "8e3af657-a8ff-443c-a75c-2fe8c4bcb635"
	UserAccessAdminRole                         = "18d7d88d-d35e-4fb5-a5c3-7773c20a72d9"
	ContributorRole                             = "b24988ac-6180-42a0-ab88-20f7382dd24c"
	AKSContributorRole                          = "ed7f3fbd-7b88-4dd4-9017-9adb7ce333f8"
	UsageSummaryReportsReaderRole               = "75934031-6c7e-415a-99d7-48dbd49e875e"
)
