// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by gen.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:35.09715 -0400 EDT m=+1.298672798
// using data from https://www.iana.org/assignments/media-types/image.csv
package mediatypes

const (
	ImageAces                            MediaType = "image/aces"                         // [SMPTE][Howard_Lukk],
	ImageApng                            MediaType = "image/apng"                         // [W3C][W3C_PNG_Working_Group],
	ImageAvci                            MediaType = "image/avci"                         // [ISO-IEC_JTC1][David_Singer],
	ImageAvcs                            MediaType = "image/avcs"                         // [ISO-IEC_JTC1][David_Singer],
	ImageAvif                            MediaType = "image/avif"                         // [Alliance_for_Open_Media][Cyril_Concolato],
	ImageBmp                             MediaType = "image/bmp"                          // [RFC7903],
	ImageCgm                             MediaType = "image/cgm"                          // [Alan_Francis],
	ImageDicomRle                        MediaType = "image/dicom-rle"                    // [DICOM_Standard_Committee][David_Clunie],
	ImageDpx                             MediaType = "image/dpx"                          // [SMPTE][SMPTE_Director_of_Standards_Development],
	ImageEmf                             MediaType = "image/emf"                          // [RFC7903],
	ImageExample                         MediaType = "image/example"                      // [RFC4735],
	ImageFits                            MediaType = "image/fits"                         // [RFC4047],
	ImageG3fax                           MediaType = "image/g3fax"                        // [RFC1494],
	ImageHeic                            MediaType = "image/heic"                         // [ISO-IEC_JTC1][David_Singer],
	ImageHeicSequence                    MediaType = "image/heic-sequence"                // [ISO-IEC_JTC1][David_Singer],
	ImageHeif                            MediaType = "image/heif"                         // [ISO-IEC_JTC1][David_Singer],
	ImageHeifSequence                    MediaType = "image/heif-sequence"                // [ISO-IEC_JTC1][David_Singer],
	ImageHej2k                           MediaType = "image/hej2k"                        // [ISO-IEC_JTC1][ITU-T],
	ImageHsj2                            MediaType = "image/hsj2"                         // [ISO-IEC_JTC1][ITU-T],
	ImageJls                             MediaType = "image/jls"                          // [DICOM_Standard_Committee][David_Clunie],
	ImageJp2                             MediaType = "image/jp2"                          // [RFC3745],
	ImageJph                             MediaType = "image/jph"                          // [ISO-IEC_JTC1][ITU-T],
	ImageJphc                            MediaType = "image/jphc"                         // [ISO-IEC_JTC1][ITU-T],
	ImageJpm                             MediaType = "image/jpm"                          // [RFC3745],
	ImageJpx                             MediaType = "image/jpx"                          // [RFC3745],
	ImageJxr                             MediaType = "image/jxr"                          // [ISO-IEC_JTC1][ITU-T],
	ImageJxrA                            MediaType = "image/jxrA"                         // [ISO-IEC_JTC1][ITU-T],
	ImageJxrS                            MediaType = "image/jxrS"                         // [ISO-IEC_JTC1][ITU-T],
	ImageJxs                             MediaType = "image/jxs"                          // [ISO-IEC_JTC1],
	ImageJxsc                            MediaType = "image/jxsc"                         // [ISO-IEC_JTC1],
	ImageJxsi                            MediaType = "image/jxsi"                         // [ISO-IEC_JTC1],
	ImageJxss                            MediaType = "image/jxss"                         // [ISO-IEC_JTC1],
	ImageKtx                             MediaType = "image/ktx"                          // [Khronos][Mark_Callow],
	ImageKtx2                            MediaType = "image/ktx2"                         // [Khronos][Mark_Callow],
	ImageNaplps                          MediaType = "image/naplps"                       // [Ilya_Ferber],
	ImagePng                             MediaType = "image/png"                          // [W3C][PNG_Working_Group],
	ImagePrsBtif                         MediaType = "image/prs.btif"                     // [Ben_Simon],
	ImagePrsPti                          MediaType = "image/prs.pti"                      // [Juern_Laun],
	ImagePwgRaster                       MediaType = "image/pwg-raster"                   // [Michael_Sweet],
	ImageSvgXml                          MediaType = "image/svg+xml"                      // [W3C][http://www.w3.org/TR/SVG/mimereg.html],
	ImageT38                             MediaType = "image/t38"                          // [RFC3362],
	ImageTiff                            MediaType = "image/tiff"                         // [RFC3302],
	ImageTiffFx                          MediaType = "image/tiff-fx"                      // [RFC3950],
	ImageVndAdobePhotoshop               MediaType = "image/vnd.adobe.photoshop"          // [Kim_Scarborough],
	ImageVndAirzipAcceleratorAzv         MediaType = "image/vnd.airzip.accelerator.azv"   // [Gary_Clueit],
	ImageVndCnsInf2                      MediaType = "image/vnd.cns.inf2"                 // [Ann_McLaughlin],
	ImageVndDeceGraphic                  MediaType = "image/vnd.dece.graphic"             // [Michael_A_Dolan],
	ImageVndDjvu                         MediaType = "image/vnd.djvu"                     // [Leon_Bottou],
	ImageVndDwg                          MediaType = "image/vnd.dwg"                      // [Jodi_Moline],
	ImageVndDxf                          MediaType = "image/vnd.dxf"                      // [Jodi_Moline],
	ImageVndDvbSubtitle                  MediaType = "image/vnd.dvb.subtitle"             // [Peter_Siebert][Michael_Lagally],
	ImageVndFastbidsheet                 MediaType = "image/vnd.fastbidsheet"             // [Scott_Becker],
	ImageVndFpx                          MediaType = "image/vnd.fpx"                      // [Marc_Douglas_Spencer],
	ImageVndFst                          MediaType = "image/vnd.fst"                      // [Arild_Fuldseth],
	ImageVndFujixeroxEdmicsMmr           MediaType = "image/vnd.fujixerox.edmics-mmr"     // [Masanori_Onda],
	ImageVndFujixeroxEdmicsRlc           MediaType = "image/vnd.fujixerox.edmics-rlc"     // [Masanori_Onda],
	ImageVndGlobalgraphicsPgb            MediaType = "image/vnd.globalgraphics.pgb"       // [Martin_Bailey],
	ImageVndMicrosoftIcon                MediaType = "image/vnd.microsoft.icon"           // [Simon_Butcher],
	ImageVndMix                          MediaType = "image/vnd.mix"                      // [Saveen_Reddy],
	ImageVndMsModi                       MediaType = "image/vnd.ms-modi"                  // [Gregory_Vaughan],
	ImageVndMozillaApng                  MediaType = "image/vnd.mozilla.apng"             // [Stuart_Parmenter],
	ImageVndNetFpx                       MediaType = "image/vnd.net-fpx"                  // [Marc_Douglas_Spencer],
	ImageVndPcoB16                       MediaType = "image/vnd.pco.b16"                  // [PCO_AG][Jan_Zeman],
	ImageVndRadiance                     MediaType = "image/vnd.radiance"                 // [Randolph_Fritz][Greg_Ward],
	ImageVndSealedPng                    MediaType = "image/vnd.sealed.png"               // [David_Petersen],
	ImageVndSealedmediaSoftsealGif       MediaType = "image/vnd.sealedmedia.softseal.gif" // [David_Petersen],
	ImageVndSealedmediaSoftsealJpg       MediaType = "image/vnd.sealedmedia.softseal.jpg" // [David_Petersen],
	ImageVndSvf                          MediaType = "image/vnd.svf"                      // [Jodi_Moline],
	ImageVndTencentTap                   MediaType = "image/vnd.tencent.tap"              // [Ni_Hui],
	ImageVndValveSourceTexture           MediaType = "image/vnd.valve.source.texture"     // [Henrik_Andersson],
	ImageVndWapWbmp                      MediaType = "image/vnd.wap.wbmp"                 // [Peter_Stark],
	ImageVndXiff                         MediaType = "image/vnd.xiff"                     // [Steven_Martin],
	ImageVndZbrushPcx                    MediaType = "image/vnd.zbrush.pcx"               // [Chris_Charabaruk],
	ImageWebp                            MediaType = "image/webp"                         // [RFC-zern-webp-12],
	ImageWmf                             MediaType = "image/wmf"                          // [RFC7903],
	ImageXEmfDEPRECATEDInFavorOfImageEmf MediaType = "image/emf"                          // [RFC7903],
	ImageXWmfDEPRECATEDInFavorOfImageWmf MediaType = "image/wmf"                          // [RFC7903],
)
