// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

// Code generated by gen.go; DO NOT EDIT.
// This file was generated at 2023-04-18 20:46:36.096859 -0400 EDT m=+2.298386598
// using data from https://www.iana.org/assignments/media-types/video.csv
package mediatypes

const (
	Video1dInterleavedParityfec        MediaType = "video/1d-interleaved-parityfec"         // [RFC6015],
	Video3gpp                          MediaType = "video/3gpp"                             // [RFC3839][RFC6381],
	Video3gpp2                         MediaType = "video/3gpp2"                            // [RFC4393][RFC6381],
	Video3gppTt                        MediaType = "video/3gpp-tt"                          // [RFC4396],
	VideoAV1                           MediaType = "video/AV1"                              // [Alliance_for_Open_Media],
	VideoBMPEG                         MediaType = "video/BMPEG"                            // [RFC3555],
	VideoBT656                         MediaType = "video/BT656"                            // [RFC3555],
	VideoCelB                          MediaType = "video/CelB"                             // [RFC3555],
	VideoDV                            MediaType = "video/DV"                               // [RFC6469],
	VideoEncaprtp                      MediaType = "video/encaprtp"                         // [RFC6849],
	VideoExample                       MediaType = "video/example"                          // [RFC4735],
	VideoFFV1                          MediaType = "video/FFV1"                             // [RFC9043],
	VideoFlexfec                       MediaType = "video/flexfec"                          // [RFC8627],
	VideoH261                          MediaType = "video/H261"                             // [RFC4587],
	VideoH263                          MediaType = "video/H263"                             // [RFC3555],
	VideoH2631998                      MediaType = "video/H263-1998"                        // [RFC4629],
	VideoH2632000                      MediaType = "video/H263-2000"                        // [RFC4629],
	VideoH264                          MediaType = "video/H264"                             // [RFC6184],
	VideoH264RCDO                      MediaType = "video/H264-RCDO"                        // [RFC6185],
	VideoH264SVC                       MediaType = "video/H264-SVC"                         // [RFC6190],
	VideoH265                          MediaType = "video/H265"                             // [RFC7798],
	VideoH266                          MediaType = "video/H266"                             // [RFC9328],
	VideoIsoSegment                    MediaType = "video/iso.segment"                      // [David_Singer][ISO-IEC_JTC1],
	VideoJPEG                          MediaType = "video/JPEG"                             // [RFC3555],
	VideoJpeg2000                      MediaType = "video/jpeg2000"                         // [RFC5371][RFC5372],
	VideoJxsv                          MediaType = "video/jxsv"                             // [RFC9134],
	VideoMj2                           MediaType = "video/mj2"                              // [RFC3745],
	VideoMP1S                          MediaType = "video/MP1S"                             // [RFC3555],
	VideoMP2P                          MediaType = "video/MP2P"                             // [RFC3555],
	VideoMP2T                          MediaType = "video/MP2T"                             // [RFC3555],
	VideoMp4                           MediaType = "video/mp4"                              // [RFC4337][RFC6381],
	VideoMP4VES                        MediaType = "video/MP4V-ES"                          // [RFC6416],
	VideoMPV                           MediaType = "video/MPV"                              // [RFC3555],
	VideoMpeg4Generic                  MediaType = "video/mpeg4-generic"                    // [RFC3640],
	VideoNv                            MediaType = "video/nv"                               // [RFC4856],
	VideoOgg                           MediaType = "video/ogg"                              // [RFC5334][RFC7845],
	VideoParityfec                     MediaType = "video/parityfec"                        // [RFC3009],
	VideoPointer                       MediaType = "video/pointer"                          // [RFC2862],
	VideoQuicktime                     MediaType = "video/quicktime"                        // [RFC6381][Paul_Lindner],
	VideoRaptorfec                     MediaType = "video/raptorfec"                        // [RFC6682],
	VideoRaw                           MediaType = "video/raw"                              // [RFC4175],
	VideoRtpEncAescm128                MediaType = "video/rtp-enc-aescm128"                 // [_3GPP],
	VideoRtploopback                   MediaType = "video/rtploopback"                      // [RFC6849],
	VideoRtx                           MediaType = "video/rtx"                              // [RFC4588],
	VideoScip                          MediaType = "video/scip"                             // [SCIP][Michael_Faller][Daniel_Hanson],
	VideoSmpte291                      MediaType = "video/smpte291"                         // [RFC8331],
	VideoSMPTE292M                     MediaType = "video/SMPTE292M"                        // [RFC3497],
	VideoUlpfec                        MediaType = "video/ulpfec"                           // [RFC5109],
	VideoVc1                           MediaType = "video/vc1"                              // [RFC4425],
	VideoVc2                           MediaType = "video/vc2"                              // [RFC8450],
	VideoVndCCTV                       MediaType = "video/vnd.CCTV"                         // [Frank_Rottmann],
	VideoVndDeceHd                     MediaType = "video/vnd.dece.hd"                      // [Michael_A_Dolan],
	VideoVndDeceMobile                 MediaType = "video/vnd.dece.mobile"                  // [Michael_A_Dolan],
	VideoVndDeceMp4                    MediaType = "video/vnd.dece.mp4"                     // [Michael_A_Dolan],
	VideoVndDecePd                     MediaType = "video/vnd.dece.pd"                      // [Michael_A_Dolan],
	VideoVndDeceSd                     MediaType = "video/vnd.dece.sd"                      // [Michael_A_Dolan],
	VideoVndDeceVideo                  MediaType = "video/vnd.dece.video"                   // [Michael_A_Dolan],
	VideoVndDirectvMpeg                MediaType = "video/vnd.directv.mpeg"                 // [Nathan_Zerbe],
	VideoVndDirectvMpegTts             MediaType = "video/vnd.directv.mpeg-tts"             // [Nathan_Zerbe],
	VideoVndDlnaMpegTts                MediaType = "video/vnd.dlna.mpeg-tts"                // [Edwin_Heredia],
	VideoVndDvbFile                    MediaType = "video/vnd.dvb.file"                     // [Peter_Siebert][Kevin_Murray],
	VideoVndFvt                        MediaType = "video/vnd.fvt"                          // [Arild_Fuldseth],
	VideoVndHnsVideo                   MediaType = "video/vnd.hns.video"                    // [Swaminathan],
	VideoVndIptvforum1dparityfec1010   MediaType = "video/vnd.iptvforum.1dparityfec-1010"   // [Shuji_Nakamura],
	VideoVndIptvforum1dparityfec2005   MediaType = "video/vnd.iptvforum.1dparityfec-2005"   // [Shuji_Nakamura],
	VideoVndIptvforum2dparityfec1010   MediaType = "video/vnd.iptvforum.2dparityfec-1010"   // [Shuji_Nakamura],
	VideoVndIptvforum2dparityfec2005   MediaType = "video/vnd.iptvforum.2dparityfec-2005"   // [Shuji_Nakamura],
	VideoVndIptvforumTtsavc            MediaType = "video/vnd.iptvforum.ttsavc"             // [Shuji_Nakamura],
	VideoVndIptvforumTtsmpeg2          MediaType = "video/vnd.iptvforum.ttsmpeg2"           // [Shuji_Nakamura],
	VideoVndMotorolaVideo              MediaType = "video/vnd.motorola.video"               // [Tom_McGinty],
	VideoVndMotorolaVideop             MediaType = "video/vnd.motorola.videop"              // [Tom_McGinty],
	VideoVndMpegurl                    MediaType = "video/vnd.mpegurl"                      // [Heiko_Recktenwald],
	VideoVndMsPlayreadyMediaPyv        MediaType = "video/vnd.ms-playready.media.pyv"       // [Steve_DiAcetis],
	VideoVndNokiaInterleavedMultimedia MediaType = "video/vnd.nokia.interleaved-multimedia" // [Petteri_Kangaslampi],
	VideoVndNokiaMp4vr                 MediaType = "video/vnd.nokia.mp4vr"                  // [Miska_M._Hannuksela],
	VideoVndNokiaVideovoip             MediaType = "video/vnd.nokia.videovoip"              // [Nokia],
	VideoVndObjectvideo                MediaType = "video/vnd.objectvideo"                  // [John_Clark],
	VideoVndRadgamettoolsBink          MediaType = "video/vnd.radgamettools.bink"           // [Henrik_Andersson],
	VideoVndRadgamettoolsSmacker       MediaType = "video/vnd.radgamettools.smacker"        // [Henrik_Andersson],
	VideoVndSealedMpeg1                MediaType = "video/vnd.sealed.mpeg1"                 // [David_Petersen],
	VideoVndSealedMpeg4                MediaType = "video/vnd.sealed.mpeg4"                 // [David_Petersen],
	VideoVndSealedSwf                  MediaType = "video/vnd.sealed.swf"                   // [David_Petersen],
	VideoVndSealedmediaSoftsealMov     MediaType = "video/vnd.sealedmedia.softseal.mov"     // [David_Petersen],
	VideoVndUvvuMp4                    MediaType = "video/vnd.uvvu.mp4"                     // [Michael_A_Dolan],
	VideoVndYoutubeYt                  MediaType = "video/vnd.youtube.yt"                   // [Google],
	VideoVndVivo                       MediaType = "video/vnd.vivo"                         // [John_Wolfe],
	VideoVP8                           MediaType = "video/VP8"                              // [RFC7741],
	VideoVP9                           MediaType = "video/VP9"                              // [RFC-ietf-payload-vp9-16],
)
