// Copyright 2023 Specter Ops, Inc.
//
// Licensed under the Apache License, Version 2.0
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

import { Link, Typography } from '@mui/material';
import { FC } from 'react';

const Abuse: FC = () => {
    return (
        <>
            <Typography variant='body2'>Currently you need access to the portal GUI to execute this abuse.</Typography>

            <Typography variant='body2'>
                The abuse involves adding or modifying an existing logic app to coerce the logic app into sending a JWT
                for its managed identity service principal to a web server you control.
            </Typography>

            <Typography variant='body2'>
                You can see a full walkthrough for executing that abuse in this blog post:
            </Typography>

            <Typography variant='body2'>
                <Link target='_blank' rel='noopener' href='https://medium.com/p/52b29354fc54'>
                    Andy Robbins - Managed Identity Attack Paths, Part 2: Logic Apps
                </Link>
            </Typography>
        </>
    );
};

export default Abuse;
